/**

   DicoPro project
   XMLTrans : an XML transducer

   Dominique Petitpierre, ISSCO, 1999
  
   Copyright (c) 1999,2000 ISSCO/University of Geneva, Geneva, Switzerland

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


*/

import org.xml.sax.HandlerBase;
import org.xml.sax.SAXParseException;

public class  XMLTransErrorHandler extends HandlerBase
{
    private static final java.lang.String rcsid
	= "@(#)$Id: XMLTransErrorHandler.java,v 1.2 1999/04/02 04:28:30 petitp Exp $";

    // treat validation errors as fatal
    public void error (SAXParseException e)
        throws SAXParseException
    {
	throw e;
    }
 
    // dump warnings too
    public void warning (SAXParseException err)
        throws SAXParseException
    {
	System.out.println ("** Warning" 
			    + ", line " + err.getLineNumber ()
			    + ", uri " + err.getSystemId ());
	System.out.println("   " + err.getMessage ());
    }
}
