/* Generated By:JJTree: Do not edit this line. ASTAttPat.java */
/**

   DicoPro project
   XMLTrans : an XML transducer

   Dominique Petitpierre, ISSCO, 1999
  
   Copyright (c) 1999,2000 ISSCO/University of Geneva, Geneva, Switzerland

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

package ch.unige.issco.xmltrans.parser;

import java.util.Vector;
import org.w3c.dom.Element;
import org.w3c.dom.Attr;
import org.w3c.dom.NamedNodeMap;

import ch.unige.issco.xmltrans.util.*;

public class ASTAttPat extends PatternNode {


    private static final java.lang.String rcsid
	= "@(#)$Id: ASTAttPat.java,v 1.9 1999/04/09 02:54:47 petitp Exp $";

    /* constants for comparison type */
    public static final int UNDEFINED = 0;
    public static final int EQUAL = 1;
    public static final int NOTEQUAL = 2;
    public static final int MATCH = 3;
    public static final int NOTMATCH = 4;
    public static final int SMALLERTHAN = 5;
    public static final int SMALLEROREQUAL = 6;
    public static final int GREATEROREQUAL = 7;
    public static final int GREATERTHAN = 8;
    public static final String TYPESTRING[]
	= {
	    "",
	    "==",
	    "!=",
	    "=~",
	    "!~",
	    "<",
	    "<=",
	    ">=",
	    ">"
	};
 
    String attid = null;
    Symbol var = null;
    String val = null;
    int compare = UNDEFINED;

    public ASTRule myRule; // rule this pattern belongs to
    // base of the double stack structure: grows but never shrinks
    public Vector varInstancesStack = new Vector(1,1);

    public ASTAttPat(int id) {
	super(id);
    }

    public ASTAttPat(XMLTransParser p, int id) {
	super(p, id);
    }

    public String toString(String prefix)
    {
	String v = "";

	if ( compare != UNDEFINED ) {
	    v = " " + TYPESTRING[compare] + " \""
		+ EscapeChar.encode(val,'"') + "\"";
	}
	if ( var == null ) {
	    return prefix + toString() + "(" + attid + v + ")";
	}
	else {
	    return (prefix + toString() + "($" + var.name
		    + "=" + attid + v + ")"); 
	}
    }

    public boolean match(Element elementNode) {
	String value;
	boolean matched;
	Attr attNode;

	// TODO: match against non CDATA attributes (ID, IDREF, etc.
	// cf. http://www.w3.org/TR/1998/REC-xml-19980210.html#NT-AttDef
	if (attid == null) {
	    matched = true;
	    attNode = null;
	}
	else {
	    // getAttributeNode fails with NullPointerException if
	    // there are not attributes. Bug in Sun's DOM implementation?
	    if (elementNode.getAttributes() == null) {
		return false;
	    }
	    // TODO: what if attribute is #IMPLIED but not specified
	    attNode = elementNode.getAttributeNode(attid);
	    if (attNode == null) { // inexistant attribute
		return false; // TODO: envisage other possibilities
		// problem: what if NOTEQUAL and inexistant
	    } 
	    value = attNode.getValue();
	    switch (compare) {
	    case UNDEFINED: // assertion: val == null
		matched = true;
		break;
	    case EQUAL:
		matched = val.equals(value);
		break;
	    case NOTEQUAL:
		matched = ! val.equals(value);
		break;
	    case MATCH:
		matched = false; // TODO: regmatch(val,value);
		break;
	    case NOTMATCH:
		matched = false; // TODO: regmatch(val,value);
		break;
	    case SMALLERTHAN: // TODO: lexicographic order? or convert to number?
		matched = false;
		break;
	    case SMALLEROREQUAL:
		matched = false;
		break;
	    case GREATEROREQUAL:
		matched = false;
		break;
	    case GREATERTHAN:
		matched = false;
		break;
	    default: // assertion: never used
		matched = false;
		break;
	    }
	}
	if (! matched) {
	    return false;
	}
        if (var != null && Debug.test(Debug.MATCHING)) {
	    Debug.msgPart(ASTRuleSet.level,"$" + var.name + ":");
	    if (attid == null) {
		NamedNodeMap attNodes = elementNode.getAttributes();
		Attr att;
		for (int i = attNodes.getLength() -1 ; i >= 0; i--) {
		    att = (Attr) attNodes.item(i);
		    Debug.msgPart(" " + att.getName()
				  + "=\"" + att.getValue() + "\"");
		}
		Debug.msg("");
	    }
	    else {
		Debug.msg(" " + attNode.getName()
			  + "=\"" + attNode.getValue() + "\"");
            }
        }
	if (nextPat == null) {
	    matched = ((ASTAttSpec) upperPat).matchRest(elementNode);
	}
	else {
	    matched = ((ASTAttPat) nextPat).match(elementNode);
	}
	if (matched && var != null) {
	    Vector varInstances
		= (Vector) varInstancesStack.elementAt(myRule.level);
	    if (attid == null) {
		NamedNodeMap attNodes = elementNode.getAttributes();
		for (int i = attNodes.getLength() -1 ; i >= 0; i--) {
		    varInstances.addElement(attNodes.item(i));
		}
	    }
	    else {
		varInstances.addElement(attNode);
	    }
	}
	return matched;
    }
}
