/* Generated By:JJTree: Do not edit this line. ASTCAttVal.java */
/**

   DicoPro project
   XMLTrans : an XML transducer

   Dominique Petitpierre, ISSCO, 1999
  
   Copyright (c) 1999,2000 ISSCO/University of Geneva, Geneva, Switzerland

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 
*/

package ch.unige.issco.xmltrans.parser;

import java.util.Vector;
import java.util.Enumeration;
import org.w3c.dom.Node;
import org.w3c.dom.Element;
import org.w3c.dom.Document;
import org.w3c.dom.Attr;
import ch.unige.issco.xmltrans.util.Symbol;
import ch.unige.issco.xmltrans.util.EscapeChar;

public class ASTCAttVal extends SimpleNode implements BuildNode {

  Symbol var = null;
  String attName = null;
  String val = null;
  int subRegExpIndex = -1;

  private static final java.lang.String rcsid
    = "@(#)$Id: ASTCAttVal.java,v 1.7 1999/04/07 15:22:54 petitp Exp $";

  public ASTCAttVal(int id) {
    super(id);
  }

  public ASTCAttVal(XMLTransParser p, int id) {
    super(p, id);
  }

    public String toString(String prefix)
    {
        if (var == null) {
            return (prefix + toString() + "(" + attName + "=\""
		    + EscapeChar.encode(val,'"') + "\")");
        }
        if (attName == null) {
            return (prefix + toString() + "($" + var.name
		    + (subRegExpIndex < 0 ? "" : "." + subRegExpIndex) + ")");
	}
	return (prefix + toString() + "(" + attName + "="
		+ "$" + var.name + ")");
    }

    public boolean build(Document doc, Node element)
    {
	Attr attNode;
	Vector varInstances;
	Enumeration v;
	ASTAttPat pat;

	boolean matched = true;
	int nChild = jjtGetNumChildren();
	
	// TODO: handle cases where value contains entity references
	if (var == null) {
	    // assertion: attName and val have been set
	    // (cf. XMLTransParser.jjt)
	    ((Element) element).setAttribute(attName,val);
	    return true;
	}
	// TODO: does it make sense to add all  attribute variable instances?
	// possibility 1: last set wins (current implementation)
	// possibility 2: first set wins (impossible now because
	// instances are not separated)
	// both: is it necessary to explore all instances (before last
	// or after first)?
	pat = (ASTAttPat) var.value;
	varInstances
	    = (Vector) pat.varInstancesStack.elementAt(pat.myRule.level);
	// TODO: improve building tracing
	// TODO + make sure what we build is garbage collectable in case
	// of later failure
	if (Debug.test(Debug.MATCHING)) {
	    Debug.msgPart(ASTRuleSet.level, "$" + var.name + ":");
	    v = varInstances.elements();
	    while (v.hasMoreElements()) {
		attNode = (Attr) v.nextElement();
		Debug.msgPart(" " + attNode.getName()
			      + "=\"" + attNode.getValue() + "\"");
	    }
	    Debug.msg("");
	}
	v = varInstances.elements();
	while (v.hasMoreElements()) {
	    attNode = (Attr) v.nextElement();
	    // Attr clone = (Attr) attNode.cloneNode(true);
	    // TODO: find out why this causes a NullPointer Exception:
	    //((Element) element).setAttributeNode(clone);
	    // TODO see if the deep cloning is necessary/dangerous
	    if (attName == null) {
		((Element) element).setAttribute(attNode.getName(),
						 attNode.getValue());
	    }
	    else {
		((Element) element).setAttribute(attName, attNode.getValue());
	    }
	}
	return true; // TODO: catch potential exception and return false
    }
}
