/* Generated By:JJTree: Do not edit this line. ASTCElt.java */
/**

   DicoPro project
   XMLTrans : an XML transducer

   Dominique Petitpierre, ISSCO, 1999
  
   Copyright (c) 1999,2000 ISSCO/University of Geneva, Geneva, Switzerland

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 
*/

package ch.unige.issco.xmltrans.parser;

import java.util.Vector;
import java.util.Enumeration;
import org.w3c.dom.Node;
import org.w3c.dom.Element;
import org.w3c.dom.Document;
import com.sun.xml.tree.XmlDocument; 

import ch.unige.issco.xmltrans.util.*;

public class ASTCElt extends SimpleNode implements BuildNode {

  private static final java.lang.String rcsid
    = "@(#)$Id: ASTCElt.java,v 1.12 1999/04/09 02:54:47 petitp Exp $";

  String elementName = null;
  Symbol var = null;
  int subRegExpIndex;
  boolean copyInstances = true;

  public ASTCElt(int id) {
    super(id);
  }

  public ASTCElt(XMLTransParser p, int id) {
    super(p, id);
  }

    public String toString(String prefix)
    {
        if (var == null ) {
            return prefix + toString() + "(" + elementName + ")";
        }
        else {
            return prefix + toString() + "($" + var.name + ")"; 
        }
    }

    public boolean build(Document doc, Node parent)
    {
	Node element;
	int firstChild;
	int nChild;
	boolean matched;
	Vector varInstances;
	Segment segment;
	Node node;
	String varName;
	ASTRegPat pat;

	if (var == null) {
	    element = doc.createElement(elementName);
	}
	else {
	    pat = (ASTRegPat) var.value;
	    varInstances
		= (Vector) pat.varInstancesStack.elementAt(pat.myRule.level);
	    // TODO: improve building tracing
	    // TODO + make sure the element is garbage collectable
	    if (Debug.test(Debug.MATCHING)) {
		varName = "$" + var.name;
		Debug.msg(ASTRuleSet.level, varName + "/* =  (copying "
			  + (copyInstances ? "all instances"
			     : "element name")
			  + ")");
		int j = 0;
		Enumeration v = varInstances.elements();
		while (v.hasMoreElements()) {
		    Debug.msg(ASTRuleSet.level,
			      varName + "/" + j + v.nextElement()) ;
		    j++;
		}
	    }
	    if (copyInstances) {
		Enumeration v = varInstances.elements();
		while (v.hasMoreElements()) {
		    segment = (Segment) v.nextElement();
		    for (int i = segment.startPos; i < segment.endPos; i++) {
			element = segment.nodeList.item(i).cloneNode(true);
			if (element.getOwnerDocument() != null) {
			    ((XmlDocument) parent.getOwnerDocument()
			     ).changeNodeOwner(element);
			}
			parent.appendChild(element);
		    }
		}
		return true;
	    }
	    if ( varInstances.size() != 1 ) { // assertions
		Debug.msg("Internal error: found "
			  + (varInstances.size() == 0 ? "no" : "too many")
			  + " variable instances: $"
			  + var.name + "/*");
		return false;
	    }
	    segment = (Segment) varInstances.elementAt(0);
	    if (segment.startPos + 1 != segment.endPos) {
		Debug.msg("Internal error: wrong size of variable:"
			  + var.name);
		return false;
	    }
	    node = segment.nodeList.item(segment.startPos);
	    if (node.getNodeType() != Node.ELEMENT_NODE) {
		Debug.msg("Internal error: wrong type of variable"
			  + var.name);
		return false;
	    }
	    element = node.cloneNode(false);
	    if (element.getOwnerDocument() != null) {
		((XmlDocument) parent.getOwnerDocument()
		 ).changeNodeOwner(element);
	    }
	    // TODO: see if copying attributes is what we always want
	    // element = doc.createElement(((Element) node).getTagName());
	    //copy attributes but not children
	}
	parent.appendChild(element);
	nChild = jjtGetNumChildren();
	if (nChild > 0 && jjtGetChild(0) instanceof ASTCAtt) {
	    // process attributes
	    firstChild = 1;
	    matched = ((BuildNode) jjtGetChild(0)).build(doc, element);
	}
	else {
	    firstChild = 0;
	    matched = true;
	}
	for (int i = firstChild; i < nChild && matched; i++) {
	    matched = ((BuildNode) jjtGetChild(i)).build(doc, element);
	}
	return matched;
    }
    
}
