/* Generated By:JJTree: Do not edit this line. ASTRegPat.java */
/**
 
   DicoPro project
   XMLTrans : an XML transducer

   Dominique Petitpierre, ISSCO, 1999
  
   Copyright (c) 1999,2000 ISSCO/University of Geneva, Geneva, Switzerland

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

package ch.unige.issco.xmltrans.parser;

import java.util.Vector;
import org.w3c.dom.NodeList;

import ch.unige.issco.xmltrans.util.*;

public class ASTRegPat extends PatternNode {

    private static final java.lang.String rcsid
	= "@(#)$Id: ASTRegPat.java,v 1.18 1999/04/07 15:22:55 petitp Exp $";

    /* constants for regular expression type */
    public static final char EXACTLYONE  = '!';
    public static final char ZEROORONE   = '?';
    public static final char ZEROORMORE  = '*';
    public static final char ONEORMORE   = '+';
    public static final char DISJUNCTION = '|';
   

    public ASTRule myRule; // rule this pattern belongs to


    public Symbol var = null;
    public char type = EXACTLYONE;

    // base of the double stack structure: grows but never shrinks
    public Vector varInstancesStack = new Vector(1,1);

    private NodeList matchedNodeList;
    private int matchedStartPos;
    private int subMatchStartPos;


    public ASTRegPat(int id) {
	super(id);
    }

    public ASTRegPat(XMLTransParser p, int id) {
	super(p, id);
    }

    public String toString(String prefix)
    {
	if (var == null ) {
	    return prefix + toString() + "(" + type + ")";
	}
	else {
	    return prefix + toString() + "($" + var.name + type + ")"; 
	}
    }
    

    public boolean match(NodeList nodeList,
			 int startPos,
			 int endPos)
    {
	PatternNode contPat;

	if (var != null) {
	    subMatchStartPos = startPos;
	    matchedStartPos = startPos;
	    matchedNodeList = nodeList;
	}
	if (type == DISJUNCTION) {
	    int i = 0;
	    int nChild = jjtGetNumChildren();

	    while ( i < nChild
		    && ! (((PatternNode) jjtGetChild(i))
			  .match(nodeList, startPos, endPos))) {
		i++;
	    }
	    return ( i < nChild ); // true if match succeeded
	}
	contPat = (PatternNode) jjtGetChild(0);
	// try longest match first
	if (contPat.match(nodeList, startPos, endPos)) {
	    return true;
	}
	if (type == EXACTLYONE || type == ONEORMORE) {
	    return false;
	}
	// empty match is allowed: backtrack
	return matchRest(nodeList,startPos,endPos);
    }

    public boolean matchRest(NodeList nodeList,
			     int startPos,
			     int endPos)
    {
	PatternNode contPat;
	NodeList savedNodeList = null;
	int savedStartPos = -1;
	boolean matched;
	Vector varInstances;
	

	if ((type == ZEROORMORE || type == ONEORMORE)
	    && startPos < endPos
	    && subMatchStartPos < startPos // last match wasn't empty 
	    ) {
	    subMatchStartPos = startPos; // mark start of this match
	    contPat = (PatternNode) jjtGetChild(0);
	    // try longest match first
	    if (contPat.match(nodeList, startPos, endPos)) {
		return true;
	    }
	    // else empty match is allowed: backtrack
	}
	if (var != null) {
	     // startPos is matchPos of last child
	    if (Debug.test(Debug.MATCHING)) {
		Debug.msg(ASTRuleSet.level,
			  "$" + var.name + " instance "
			  + new Segment(matchedNodeList, matchedStartPos,
					startPos));
	    }
	    // save instance position against later matches of the same RegPat
	    savedNodeList = matchedNodeList;
	    savedStartPos = matchedStartPos;
	}
	if (nextPat != null ) {
	    matched = nextPat.match(nodeList, startPos, endPos);
	}
	else if (upperPat != null) {
	    matched = ((ASTRegPat) upperPat).matchRest(nodeList,
						       startPos, endPos);
	}
	else {
	    matched = (startPos == endPos);
	}
	if (var != null && matched) {
	    varInstances = (Vector) varInstancesStack.elementAt(myRule.level);
	    // TODO: check if an empty instance has to be recorded
	    varInstances.addElement(new Segment(savedNodeList,savedStartPos,
					  startPos));
	}
	return matched;
    }

    public void assignNextPat()
    {
	PatternNode subPat;
	PatternNode followPat = null;
	boolean isDisjunction;

	isDisjunction = (type == DISJUNCTION);
	for (int i = jjtGetNumChildren() - 1 ; i >= 0; i--) {
	    subPat = (PatternNode) jjtGetChild(i);
	    subPat.upperPat = this;	
	    if (isDisjunction) {
		subPat.nextPat = null;
	    }
	    else {
		subPat.nextPat = followPat;
		followPat = subPat;
	    }
	    if (subPat instanceof ASTRegPat
		|| subPat instanceof ASTElementPat) {
		subPat.assignNextPat();
	    }
	}
    }

}

