/* Generated By:JJTree: Do not edit this line. ASTRule.java */
/**

   DicoPro project
   XMLTrans : an XML transducer

   Dominique Petitpierre, ISSCO, 1999
  
   Copyright (c) 1999,2000 ISSCO/University of Geneva, Geneva, Switzerland

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 
*/

package ch.unige.issco.xmltrans.parser;

import java.util.Enumeration;
import java.util.Vector;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;
import org.w3c.dom.Document;

import ch.unige.issco.xmltrans.util.*;

public class ASTRule extends PatternNode implements BuildNode {

  private static final java.lang.String rcsid
    = "@(#)$Id: ASTRule.java,v 1.21 1999/04/12 14:26:36 petitp Exp $";

  public int level = -1;
  public int levelMax = -1;


    // fits confortably 6
    public XMLTransSymTable eltSeqVars
	= new XMLTransSymTable(13, (float) 0.5, "elements variable");
    // fits confortably 6
    public XMLTransSymTable attVars
	= new XMLTransSymTable(13, (float) 0.5, "attribute variable");

  public ASTRule(int id) {
    super(id);
  }

  public ASTRule(XMLTransParser p, int id) {
    super(p, id);
  }

    public  void jjtClose()
    {
	PatternNode lhs;

	if (Debug.test(Debug.PARSING)) {
	    Debug.msg("Element sequence variables:\n"
		      + eltSeqVars.toString());
	}
        XMLTransParser.parseErrors |= ! eltSeqVars.checkRef();
	if (Debug.test(Debug.PARSING)) {
	    Debug.msg("Attribute variables:\n"
		      + attVars.toString());
	}
        XMLTransParser.parseErrors |= ! attVars.checkRef();
	lhs = (PatternNode) jjtGetChild(0);
	lhs.nextPat = null;
	lhs.upperPat = null;
	lhs.assignNextPat();
    }

    public boolean match(NodeList nodeList,
			 int startPos,
			 int endPos,
			 Document doc,
			 Node parent)

    {
	PatternNode lhs;
	boolean matched;
	Segment segment;
	String signature;
	Enumeration e;
	ASTRegPat pat;
	ASTAttPat attPat;
	int nChild;

	level++;
	if (level > levelMax) {
	    levelMax++;
	    e = eltSeqVars.elements();
	    while (e.hasMoreElements()) {
		pat = (ASTRegPat) ((Symbol) e.nextElement()).value;
		pat.varInstancesStack.addElement(new Vector(1,1));
	    }
	    e = attVars.elements();
	    while (e.hasMoreElements()) {
		attPat = (ASTAttPat) ((Symbol) e.nextElement()).value;
		attPat.varInstancesStack.addElement(new Vector(1,1));
	    }
	}
	lhs = (PatternNode) jjtGetChild(0);
	if (! lhs.match(nodeList, startPos, endPos)) {
	    level--;
	    return false;
	}
	if (Debug.test(Debug.MATCHING)) {
	    Debug.msg(ASTRuleSet.level, "Lhs template matched.");
	}
	// build the rhs
	nChild = parent.getChildNodes().getLength();
	matched = build(doc,parent);
	if (! matched) {
	    // discard any newly built structure
	    // TODO: see if another method is more efficient:
	    // getSibling variety or collecting built nodes after success
	    for (int i = parent.getChildNodes().getLength() - 1 ;
		 i >= nChild; i--) {
		 parent.removeChild(parent.getChildNodes().item(i));
	    }
	}
	// free all the variable instances that were created at this level
	// but keep the structure of the double stack
	e = eltSeqVars.elements();
	while (e.hasMoreElements()) {
	    pat = (ASTRegPat) ((Symbol) e.nextElement()).value;
	    ((Vector) pat.varInstancesStack.elementAt(level)
	     ).removeAllElements();
	}
	e = attVars.elements();
	while (e.hasMoreElements()) {
	    attPat = (ASTAttPat) ((Symbol) e.nextElement()).value;
	    ((Vector) attPat.varInstancesStack.elementAt(level)
	     ).removeAllElements();
	}
	level --;
	return matched;
    }

    public boolean build(Document doc, Node parent)
    {
	int nChild;
	boolean matched = true;

	nChild = jjtGetNumChildren(); // rhs starts at 1
	for (int i = 1; i < nChild && matched; i++) {
	    matched = ((BuildNode) jjtGetChild(i)).build(doc, parent);
	}
	return matched;
    }
}
