/* Generated By:JJTree: Do not edit this line. ASTRuleSet.java */
/**

   DicoPro project
   XMLTrans : an XML transducer

   Dominique Petitpierre, ISSCO, 1999
  
   Copyright (c) 1999,2000 ISSCO/University of Geneva, Geneva, Switzerland

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 
*/

package ch.unige.issco.xmltrans.parser;

import java.util.Enumeration;
import java.util.Vector;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Document;

import ch.unige.issco.xmltrans.util.*;

public class ASTRuleSet extends PatternNode {

  private static final java.lang.String rcsid
    = "@(#)$Id: ASTRuleSet.java,v 1.17 1999/04/09 05:25:14 petitp Exp $";


    public static final String defaultName = "@default";

    public static int level = 0; // recursion level for all rule set

    public Symbol set;

  public ASTRuleSet(int id) {
    super(id);
  }

  public ASTRuleSet(XMLTransParser p, int id) {
    super(p, id);
  }

  public String toString(String prefix)
    {
	if (set == null)
	    {
		return prefix + toString() + "(" + "*bad*" + ")";
	    }
	else
	    {
		return prefix + toString() + "(" + set.name + ")";
	    }
    }

    public boolean match(Vector varInstances, Document doc, Node parent)
    {
	Segment segment;
	Enumeration e = varInstances.elements();
	boolean matched = true;

	level++;
	while ( e.hasMoreElements() && matched ) {
	    segment = (Segment) e.nextElement();
	    matched = match(segment.nodeList, segment.startPos,
			    segment.endPos, doc, parent);
	}
	level--;
	return matched;
    }

    public boolean match(NodeList nodeList, int startPos, int endPos,
			 Document doc, Node parent)
    {
	int nRule;
	int i;
	int j;
	ASTRule rule;
	boolean matched = true;

 
	nRule = jjtGetNumChildren();
	for (int pos = startPos; pos < endPos && matched; pos++) {
	    i = 0; // all rule sets have at least one rule
	    do { // first rule that matches wins: no backtracking
		rule = (ASTRule) jjtGetChild(i);
		if (Debug.test(Debug.MATCHING)) {
		    Debug.msg(level,
			      "@" + set.name + "/" + i
			      + "^" + (rule.level + 1) 
			      + ": trying rule");
		}
		// to skip to just lhs matching use:
		// rule = (PatternNode) jjtGetChild(i).jjtGetChild(0);
		matched = rule.match(nodeList, pos, pos + 1, doc, parent);
		if (! matched && Debug.test(Debug.MATCHING)) {
		    Debug.msg(level,
			      "@" + set.name + "/" + i
			      + "^" + (rule.level + 1) 
			      + ": failed rule.");
		}
		i++;
	    } while ( i < nRule && ! matched);
	    if (matched && Debug.test(Debug.MATCHING|Debug.MATCHED)) {
		Debug.msg(level,
			  "@" + set.name + "/" + --i
			  + "^" + (rule.level + 1) 
			  + ": succeeded.");
	    }
	}
	return matched;
    }
}
