/* Generated By:JJTree: Do not edit this line. ASTStringPat.java */
/**

   DicoPro project
   XMLTrans : an XML transducer

   Dominique Petitpierre, ISSCO, 1999
  
   Copyright (c) 1999,2000 ISSCO/University of Geneva, Geneva, Switzerland

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 
*/

package ch.unige.issco.xmltrans.parser;

import org.w3c.dom.Node;
import org.w3c.dom.Text;

import ch.unige.issco.xmltrans.util.*;

public class ASTStringPat extends PatternNode {

  private static final java.lang.String rcsid
    = "@(#)$Id: ASTStringPat.java,v 1.9 1999/04/09 08:53:32 petitp Exp $";

  String val;
  boolean negate = false;

  public ASTStringPat(int id) {
    super(id);
  }

  public ASTStringPat(XMLTransParser p, int id) {
    super(p, id);
  }

  public String toString(String prefix)
  {
      return (prefix + toString() + "(\""
	      + (negate?"!":"") + EscapeChar.encode(val,'"') + "\")" );
  }
    // TODO: check what happens with an empty string (val or text)
    public boolean match(Node node)

    {
	boolean matched;

	if (node == null) {
	    return false; // TODO: what if pattern is the empty string?
	}
	short nodeType = node.getNodeType();
	if (nodeType != Node.CDATA_SECTION_NODE
	    && nodeType != Node.TEXT_NODE ) {
	    matched = false; // was expecting a text node
	    // TODO: what if negation
	}
	else {
	    if (Debug.test(Debug.MATCHING)) {
		Debug.msg(ASTRuleSet.level,
			  "\"" + EscapeChar.encode(val,'"') + "\" == \""
			  + EscapeChar.encode(((Text) node).getData(),'"')
			  + "\" : " + val.equals( ((Text) node).getData() ));
	    }
	    matched = val.equals( ((Text) node).getData());
	}
	if (negate) {
	    return ! matched;
	}
	else {
	    return matched;
	}
	/*
	  length = textNode.getLength();
	  if (length < val.length()) {
	  return -1;
	  }
	  if ( ! val.startsWith(textNode.getData()) ) { // match text
	  return -1;
	  }
	  if (length > val.length()) {
	  // assertion: no indexes past this node have been recorded
	  textNode.splitText(val.length());
	  }
	*/
    }
}

