/**

   DicoPro project
   XMLTrans : an XML transducer

   Dominique Petitpierre, ISSCO, 1999
  
   Copyright (c) 1999,2000 ISSCO/University of Geneva, Geneva, Switzerland

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

package ch.unige.issco.xmltrans.parser;

import ch.unige.issco.xmltrans.util.BitMap;

public class Debug extends BitMap
{

    private static final java.lang.String rcsid
        = "@(#)$Id: Debug.java,v 1.1 1999/04/02 04:28:34 petitp Exp $";

    /* constants for debug bitmap */
    public static final int NONE = BitMap.NONE;
    public static final int PARSING = BitMap.BIT0;
    public static final int PARSED = BitMap.BIT1;
    public static final int MATCHING = BitMap.BIT2;
    public static final int MATCHED = BitMap.BIT3;
    public static final int CONSTRUCTING = BitMap.BIT4;
    public static final int CONSTRUCTED = BitMap.BIT5;
    public static final int REGEXP = BitMap.BIT6;
    public static final int XMLPARSE = BitMap.BIT7;
    public static final int ASSERTION = BitMap.BIT8;
    public static final int ALL = BitMap.ALL;


    public static char indentChar = ' ';

    /* too costly because message is usually a complex expression
    public static void msg(int debugBits, String message)
    {
	if ( test(debugBits) ) {
	    System.err.println(message);
	}
    }
    */

    public static void msg(String message)
    {
	System.err.println(message);
    }

    public static void msgPart(String message)
    {
	System.err.print(message);
    }

    public static void msgPart(int indent, String message)
    {
	for (int i=0; i < indent; i++) {
	    System.err.print(indentChar);
	}
	System.err.print(message);
    }

    public static void msg(int indent, String message)
    {
	for (int i=0; i < indent; i++) {
	    System.err.print(indentChar);
	}
	System.err.println(message);
    }
}
