/**

   DicoPro project
   XMLTrans : an XML transducer

   Dominique Petitpierre, ISSCO, 1999
  
   Copyright (c) 1999,2000 ISSCO/University of Geneva, Geneva, Switzerland

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 
*/

package ch.unige.issco.xmltrans.parser;

import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class Segment
{
    private static final java.lang.String rcsid
	= "@(#)$Id: Segment.java,v 1.4 1999/04/07 10:34:30 petitp Exp $";

    public NodeList nodeList;
    public int startPos;
    public int endPos;

    Segment(NodeList nodeList, int startPos, int endPos)
    {
	this.nodeList = nodeList;
	this.startPos = startPos;
	this.endPos = endPos;
    }

    public String toString()
    {
	String s;

	s = "{";
	for (int i = startPos; i < endPos; i++) {
	    s += nodeTypeSignature((short) nodeList.item(i).getNodeType());
	}
	s += "}=" ;
	for (int i = startPos; i < endPos; i++) {
	    s += "\n" + nodeList.item(i);
	}
	return s;
    }

   public static String nodeTypeSignature(short nodeType)
    {
	switch (nodeType) {
	case Node.ATTRIBUTE_NODE : return "A";
	case Node.CDATA_SECTION_NODE : return "T";
	case Node.COMMENT_NODE : return "C";
	case Node.DOCUMENT_FRAGMENT_NODE : return "F";
	case Node.DOCUMENT_NODE : return "D";
	case Node.DOCUMENT_TYPE_NODE : return "Y";
	case Node.ELEMENT_NODE : return "e";
	case Node.ENTITY_NODE : return "E";
	case Node.ENTITY_REFERENCE_NODE : return "r";
	case Node.NOTATION_NODE : return "N";
	case Node.PROCESSING_INSTRUCTION_NODE : return "P";
	case Node.TEXT_NODE : return "t";
	default: return "?";
	}
    }
}
