/**

   DicoPro project
   XMLTrans : an XML transducer

   Dominique Petitpierre, ISSCO, 1999
  
   Copyright (c) 1999,2000 ISSCO/University of Geneva, Geneva, Switzerland

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

package ch.unige.issco.xmltrans.util;

public class BitMap
{
    private static final java.lang.String rcsid
        = "@(#)$Id: BitMap.java,v 1.2 1999/04/02 04:28:36 petitp Exp $";

    /* constants for  bitmap */
    public static final int NONE = 0;
    public static final int BIT0 = 1;
    public static final int BIT1 = 1 << 1;
    public static final int BIT2 = 1 << 2;
    public static final int BIT3 = 1 << 3;
    public static final int BIT4 = 1 << 4;
    public static final int BIT5 = 1 << 5;
    public static final int BIT6 = 1 << 6;
    public static final int BIT7 = 1 << 7;
    public static final int BIT8 = 1 << 8;
    public static final int BIT9 = 1 << 9;
    public static final int BIT10 = 1 << 10;
    public static final int BIT11 = 1 << 11;
    public static final int BIT12 = 1 << 12;
    public static final int BIT13 = 1 << 13;
    public static final int BIT14 = 1 << 14;
    public static final int BIT15 = 1 << 15;
    public static final int BIT16 = 1 << 16;
    public static final int BIT17 = 1 << 17;
    public static final int BIT18 = 1 << 18;
    public static final int BIT19 = 1 << 19;
    public static final int BIT20 = 1 << 20;
    public static final int BIT21 = 1 << 21;
    public static final int BIT22 = 1 << 22;
    public static final int BIT23 = 1 << 23;
    public static final int BIT24 = 1 << 24;
    public static final int BIT25 = 1 << 25;
    public static final int BIT26 = 1 << 26;
    public static final int BIT27 = 1 << 27;
    public static final int BIT28 = 1 << 28;
    public static final int BIT29 = 1 << 29;
    public static final int BIT30 = 1 << 30;
    public static final int BIT31 = 1 << 31;
    public static final int ALL   = ~ 0;

    public static int bitMap = NONE;

    public static void add(int bits)
    {
	bitMap |= bits;
    }

    public static void remove(int bits)
    {
	bitMap &= ~ bits;
    }

    public static void set(int bits)
    {
	bitMap = bits;
    }

    public static int get()
    {
	return bitMap;
    }


    public static boolean test(int bits)
    {
	return ( (bits & bitMap) != 0 );
    }


}
