/**

   DicoPro project
   XMLTrans : an XML transducer

   Dominique Petitpierre, ISSCO, 1999
  
   Copyright (c) 1999,2000 ISSCO/University of Geneva, Geneva, Switzerland

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 
*/

package ch.unige.issco.xmltrans.util;

import java.util.Hashtable;
import java.util.Enumeration;

public class SymTable extends Hashtable
{
    private static final java.lang.String rcsid
	= "@(#)$Id: SymTable.java,v 1.5 1999/04/02 04:28:37 petitp Exp $";

    public String symbolKind = null;

    public SymTable()
    {
	super();
    }

    public SymTable(int initialCapacity)
    {
	super(initialCapacity);
    }

    public SymTable(int initialCapacity, float loadFactor)
    {
	super(initialCapacity, loadFactor);
    }

    public SymTable(int initialCapacity, float loadFactor, String kind)
    {
	super(initialCapacity, loadFactor);
	symbolKind = kind;
    }

    public String toString() //overrides
    {
	Enumeration e = elements();
	String s = "";
	String key;

	while (e.hasMoreElements()) {
	    s = s + e.nextElement() + "\n";
	}
	return s;
    }

    public Symbol define(Symbol symbol) // could be synchronized
    {
	Symbol oldSym;

	oldSym = (Symbol) get(symbol.name);
	if (oldSym == null) {
	    symbol.referenced = 0;
	    symbol.defined = 1;
	    put(symbol.name, symbol);
	    return symbol;
	}
	else {
	    oldSym.defined++;
	    return oldSym;
	}
    }
    
    public Symbol reference(Symbol symbol)  // could be synchronized
    {
	Symbol oldSym;

	oldSym = (Symbol) get(symbol.name);
	if (oldSym == null) {
	    symbol.referenced = 1;
	    symbol.defined = 0;
	    put(symbol.name, symbol);
	    return symbol;
	}
	else {
	    oldSym.referenced++;
	    return oldSym;
	}
    }
}
