/**

   DicoPro project
   XMLTrans : an XML transducer

   Dominique Petitpierre, ISSCO, 1999
  
   Copyright (c) 1999,2000 ISSCO/University of Geneva, Geneva, Switzerland

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 
*/

package ch.unige.issco.xmltrans.util;

public class Symbol
{
    private static final java.lang.String rcsid
	= "@(#)$Id: Symbol.java,v 1.5 1999/04/02 04:28:37 petitp Exp $";

    public String name;
    public String sourceFile;
    public int sourceLine;
    public int sourceColumn;
    public Object value;
    public int defined = 0;
    public int referenced = 0;

    public Symbol()
    {
	super();
    }

    public Symbol(String n, String file, int line, int column, Object val)
    {
	name = n;
	sourceFile = file;
	sourceLine = line;
	sourceColumn = column;
	value = val;
    }

    public Symbol(String n, int line, int column, Object val)
    {
	name = n;
	sourceFile = null;
	sourceLine = line;
	sourceColumn = column;
	value = val;
    }

    public Symbol(String n, int line, int column)
    {
	name = n;
	sourceFile = null;
	sourceLine = line;
	sourceColumn = column;
	value = null;
    }


    public String toString()
    {
	return ("name=" + name
		+ " line=" + sourceLine
		+ " column=" + sourceColumn
		+ " file=" + sourceFile
		+ " value=(" + value
		+ ") defined=" + defined
		+ " referenced=" + referenced
		);
    }
}
